=== host/libraries/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
add_subdirectory(libbladeRF)
