=== host/libraries/libbladeRF/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
add_subdirectory(test_async)
add_subdirectory(test_repeater)
