=== debian/changelog ===
bladerf (0.9.0.15.8ba2499-1) unstable; urgency=low

  * new upstream version

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 27 Dec 2013 12:15:29 -0500

bladerf (0.8.0.14.9126eac-1) unstable; urgency=low

  * New Debian Package (Closes: #724967)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 25 Nov 2013 23:51:56 -0500
